From b39146131571f7f90d9962efc9510df6daccd285 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Mon, 19 Mar 2012 13:13:05 -0500
Subject: [PATCH] Removed unused SystemIdentity and SystemSigner.

The SystemIdentity and SystemSigner classes have been removed
because they are based on deprecated classes and are not used
anywhere in the code.

Ticket #3
---
 pki/base/util/src/CMakeLists.txt                   |    2 -
 .../netscape/security/provider/SystemIdentity.java |   80 -----------------
 .../netscape/security/provider/SystemSigner.java   |   91 --------------------
 3 files changed, 0 insertions(+), 173 deletions(-)
 delete mode 100644 pki/base/util/src/netscape/security/provider/SystemIdentity.java
 delete mode 100644 pki/base/util/src/netscape/security/provider/SystemSigner.java

diff --git a/pki/base/util/src/CMakeLists.txt b/pki/base/util/src/CMakeLists.txt
index a9c95837f1f1aaaed7e44e1fdcb624baf355da4b..592e3b59bcaab79c5c625df8956c0d050241c3ba 100644
--- a/pki/base/util/src/CMakeLists.txt
+++ b/pki/base/util/src/CMakeLists.txt
@@ -187,10 +187,8 @@ set(pki-nsutil_java_SRCS
     netscape/security/provider/DSAPrivateKey.java
     netscape/security/provider/DSAParameters.java
     netscape/security/provider/DSAPublicKey.java
-    netscape/security/provider/SystemIdentity.java
     netscape/security/provider/RSAPublicKey.java
     netscape/security/provider/SHA.java
-    netscape/security/provider/SystemSigner.java
     netscape/security/provider/MD5.java
     netscape/security/provider/DSAParameterGenerator.java
     netscape/security/provider/CMS.java
diff --git a/pki/base/util/src/netscape/security/provider/SystemIdentity.java b/pki/base/util/src/netscape/security/provider/SystemIdentity.java
deleted file mode 100644
index 37f707889a635b57e4d22f92ed345ad6b937e094..0000000000000000000000000000000000000000
--- a/pki/base/util/src/netscape/security/provider/SystemIdentity.java
+++ /dev/null
@@ -1,80 +0,0 @@
-// --- BEGIN COPYRIGHT BLOCK ---
-// This program is free software; you can redistribute it and/or modify
-// it under the terms of the GNU General Public License as published by
-// the Free Software Foundation; version 2 of the License.
-//
-// This program is distributed in the hope that it will be useful,
-// but WITHOUT ANY WARRANTY; without even the implied warranty of
-// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// GNU General Public License for more details.
-//
-// You should have received a copy of the GNU General Public License along
-// with this program; if not, write to the Free Software Foundation, Inc.,
-// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-//
-// (C) 2007 Red Hat, Inc.
-// All rights reserved.
-// --- END COPYRIGHT BLOCK ---
-package netscape.security.provider;
-
-import java.io.Serializable;
-import java.security.Certificate;
-import java.security.Identity;
-import java.security.IdentityScope;
-import java.security.InvalidParameterException;
-import java.security.KeyManagementException;
-import java.security.PublicKey;
-
-/**
- * An identity.
- * 
- * @version 1.19, 09/12/97
- * @author Benjamin Renaud
- */
-
-public class SystemIdentity extends Identity implements Serializable {
-
-    /** use serialVersionUID from JDK 1.1. for interoperability */
-    private static final long serialVersionUID = 9060648952088498478L;
-
-    /* Free form additional information about this identity. */
-    private String info;
-
-    /* This exists only for serialization bc and don't use it! */
-    private boolean trusted = false;
-
-    public SystemIdentity(String name, IdentityScope scope)
-            throws InvalidParameterException, KeyManagementException {
-        super(name, scope);
-    }
-
-    void setIdentityInfo(String info) {
-        super.setInfo(info);
-    }
-
-    String getIndentityInfo() {
-        return super.getInfo();
-    }
-
-    /**
-     * Call back method into a protected method for package friends.
-     */
-    void setIdentityPublicKey(PublicKey key) throws KeyManagementException {
-        setPublicKey(key);
-    }
-
-    /**
-     * Call back method into a protected method for package friends.
-     */
-    void addIdentityCertificate(Certificate cert)
-            throws KeyManagementException {
-        addCertificate(cert);
-    }
-
-    void clearCertificates() throws KeyManagementException {
-        Certificate[] certs = certificates();
-        for (int i = 0; i < certs.length; i++) {
-            removeCertificate(certs[i]);
-        }
-    }
-}
diff --git a/pki/base/util/src/netscape/security/provider/SystemSigner.java b/pki/base/util/src/netscape/security/provider/SystemSigner.java
deleted file mode 100644
index cf9a78cc2167ba690eb4abda3633d8b728a82eaa..0000000000000000000000000000000000000000
--- a/pki/base/util/src/netscape/security/provider/SystemSigner.java
+++ /dev/null
@@ -1,91 +0,0 @@
-// --- BEGIN COPYRIGHT BLOCK ---
-// This program is free software; you can redistribute it and/or modify
-// it under the terms of the GNU General Public License as published by
-// the Free Software Foundation; version 2 of the License.
-//
-// This program is distributed in the hope that it will be useful,
-// but WITHOUT ANY WARRANTY; without even the implied warranty of
-// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// GNU General Public License for more details.
-//
-// You should have received a copy of the GNU General Public License along
-// with this program; if not, write to the Free Software Foundation, Inc.,
-// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-//
-// (C) 2007 Red Hat, Inc.
-// All rights reserved.
-// --- END COPYRIGHT BLOCK ---
-package netscape.security.provider;
-
-import java.security.Certificate;
-import java.security.IdentityScope;
-import java.security.InvalidParameterException;
-import java.security.KeyException;
-import java.security.KeyManagementException;
-import java.security.KeyPair;
-import java.security.PrivateKey;
-import java.security.Signer;
-
-/**
- * SunSecurity signer.
- * 
- * @version 1.24, 09/12/97
- * @author Benjamin Renaud
- */
-public class SystemSigner extends Signer {
-
-    /** use serialVersionUID from JDK 1.1. for interoperability */
-    private static final long serialVersionUID = -2127743304301557711L;
-
-    /* This exists only for serialization bc and don't use it! */
-    private boolean trusted = false;
-
-    /**
-     * Construct a signer with a given name.
-     */
-    public SystemSigner(String name) {
-        super(name);
-    }
-
-    /**
-     * Construct a signer with a name and a scope.
-     * 
-     * @param name the signer's name.
-     * 
-     * @param scope the scope for this signer.
-     */
-    public SystemSigner(String name, IdentityScope scope)
-            throws KeyManagementException {
-
-        super(name, scope);
-    }
-
-    /* friendly callback for set keys */
-    void setSignerKeyPair(KeyPair pair)
-            throws InvalidParameterException, KeyException {
-        setKeyPair(pair);
-    }
-
-    /* friendly callback for getting private keys */
-    PrivateKey getSignerPrivateKey() {
-        return getPrivateKey();
-    }
-
-    void setSignerInfo(String s) {
-        setInfo(s);
-    }
-
-    /**
-     * Call back method into a protected method for package friends.
-     */
-    void addSignerCertificate(Certificate cert) throws KeyManagementException {
-        addCertificate(cert);
-    }
-
-    void clearCertificates() throws KeyManagementException {
-        Certificate[] certs = certificates();
-        for (int i = 0; i < certs.length; i++) {
-            removeCertificate(certs[i]);
-        }
-    }
-}
-- 
1.7.7.1.msysgit.0